## org.apache.commons.math.linear
Class SingularValueDecompositionImpl.Solver

    java.lang.Object
      org.apache.commons.math.linear.SingularValueDecompositionImpl.Solver

All Implemented Interfaces:
  DecompositionSolver

Enclosing class:
  SingularValueDecompositionImpl

    private static class SingularValueDecompositionImpl.Solver

extends Object
implements DecompositionSolver

Specialized solver.

Field Summary
`private boolean` `nonSingular` Singularity indicator.
`private RealMatrix` `pseudoInverse` Pseudo-inverse of the initial matrix.

Constructor Summary
`private` `SingularValueDecompositionImpl.Solver(double[] singularValues, RealMatrix uT, RealMatrix v, boolean nonSingular)` Build a solver from decomposed matrix.

Method Summary
`RealMatrix` `getInverse()` Get the pseudo-inverse of the decomposed matrix.
`boolean` `isNonSingular()` Check if the decomposed matrix is non-singular.
`double[]` `solve(double[] b)` Solve the linear equation A × X = B in least square sense.
`RealMatrix` `solve(RealMatrix b)` Solve the linear equation A × X = B in least square sense.
`RealVector` `solve(RealVector b)` Solve the linear equation A × X = B in least square sense.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### pseudoInverse

    private final RealMatrix pseudoInverse

  Pseudo-inverse of the initial matrix.

### nonSingular

    private boolean nonSingular

  Singularity indicator.

Constructor Detail

### SingularValueDecompositionImpl.Solver

    private SingularValueDecompositionImpl.Solver(double[] singularValues,
                                                  RealMatrix uT,
                                                  RealMatrix v,
                                                  boolean nonSingular)

  Build a solver from decomposed matrix.

  Parameters:
    `singularValues` - singularValues
    `uT` - UT matrix of the decomposition
    `v` - V matrix of the decomposition
    `nonSingular` - singularity indicator

Method Detail

### solve

    public double[] solve(double[] b)
                   throws IllegalArgumentException

  Solve the linear equation A × X = B in least square sense.

  The m×n matrix A may not be square, the solution X is such that ||A × X - B|| is minimal.

  Specified by:
    `solve` in interface `DecompositionSolver`
  Parameters:
    `b` - right-hand side of the equation A × X = B
  Returns:
    a vector X that minimizes the two norm of A × X - B
  Throws:
    `IllegalArgumentException` - if matrices dimensions don't match

### solve

    public RealVector solve(RealVector b)
                     throws IllegalArgumentException

  Solve the linear equation A × X = B in least square sense.

  The m×n matrix A may not be square, the solution X is such that ||A × X - B|| is minimal.

  Specified by:
    `solve` in interface `DecompositionSolver`
  Parameters:
    `b` - right-hand side of the equation A × X = B
  Returns:
    a vector X that minimizes the two norm of A × X - B
  Throws:
    `IllegalArgumentException` - if matrices dimensions don't match

### solve

    public RealMatrix solve(RealMatrix b)
                     throws IllegalArgumentException

  Solve the linear equation A × X = B in least square sense.

  The m×n matrix A may not be square, the solution X is such that ||A × X - B|| is minimal.

  Specified by:
    `solve` in interface `DecompositionSolver`
  Parameters:
    `b` - right-hand side of the equation A × X = B
  Returns:
    a matrix X that minimizes the two norm of A × X - B
  Throws:
    `IllegalArgumentException` - if matrices dimensions don't match

### isNonSingular

    public boolean isNonSingular()

  Check if the decomposed matrix is non-singular.

  Specified by:
    `isNonSingular` in interface `DecompositionSolver`
  Returns:
    true if the decomposed matrix is non-singular

### getInverse

    public RealMatrix getInverse()

  Get the pseudo-inverse of the decomposed matrix.

  Specified by:
    `getInverse` in interface `DecompositionSolver`
  Returns:
    inverse matrix

Copyright (c) 2003-2013 Apache Software Foundation